#include "main.h"

#define IACLEN	3

static void SendIAC(unsigned char cmd,unsigned char opt)
{
	tcp.Sendf("%c%c%c",IAC,cmd,opt);
}


void ProcessIAC()
{
 while (tcp.GetBuffer()[0]==IAC && tcp.GetBufferLen()>=IACLEN-1) {
	unsigned char cmd=tcp.GetBuffer()[1];
	unsigned char opt=tcp.GetBuffer()[2];
	switch (cmd) {
        case WILL: if (tcp.GetBufferLen()>=IACLEN) {
						switch (opt) {
							case TELOPT_ECHO:
								{
									if (scr.local_echo!=0) {
										scr.local_echo=0;
										SendIAC(DO,TELOPT_ECHO);
									}
									tcp.BufferDel(IACLEN);
									break;
								}
							case TELOPT_SGA:
								{
									if (scr.local_echo!=0) {
										SendIAC(DO,TELOPT_SGA);
										SendIAC(DO,TELOPT_ECHO);
									}
									tcp.BufferDel(IACLEN);
									break;
								}
							default: SendIAC(DONT,opt); tcp.BufferDel(IACLEN);
						}
						break;
				   }
        case WONT: if (tcp.GetBufferLen()>=IACLEN) {
						switch (opt) {
							case TELOPT_ECHO: 
								{
									if (scr.local_echo==0) {
										scr.local_echo=1;
										SendIAC(DONT,TELOPT_ECHO);
									}
									tcp.BufferDel(IACLEN);
									break;
								}
							case TELOPT_SGA: 
								{
									if (scr.local_echo==0) {
										scr.local_echo=1;
										SendIAC(DONT,TELOPT_SGA);
									}
									tcp.BufferDel(IACLEN);
									break;
								}
							default: SendIAC(WONT,opt); tcp.BufferDel(IACLEN);
						}
						break;
				   }
        case DO:   if (tcp.GetBufferLen()>=IACLEN) {
						switch (opt) {
							case TELOPT_ECHO: 
								{
									scr.local_echo=0;
									SendIAC(WONT,TELOPT_ECHO);
									SendIAC(DO,TELOPT_ECHO);
									tcp.BufferDel(IACLEN);
									break;
								}
		 					case TELOPT_TTYPE:	SendIAC(WILL,opt); tcp.BufferDel(IACLEN); break;
							default: SendIAC(WONT,opt); SendIAC(DONT,opt); tcp.BufferDel(IACLEN);
						}
				   }
 				   break;
        case DONT: if (tcp.GetBufferLen()>=IACLEN) {
						switch (opt) {
							case TELOPT_ECHO: 
								{
									scr.local_echo=0;
									SendIAC(WONT,TELOPT_ECHO);
									tcp.BufferDel(IACLEN);
									break;
								}
							default: SendIAC(WONT,opt); tcp.BufferDel(IACLEN);
						}
						break;
				   }
        //case DONT: buf.Del(IACLEN); break;
		case SB:   switch (opt)	{
						case TELOPT_LOGOUT:
						 	if (tcp.GetBufferLen()>=4 && tcp.GetBuffer()[3]==TELQUAL_SEND) {
                			   tcp.BufferDel(4);
						    }
							break;
						case TELOPT_TTYPE:
						 	if (tcp.GetBufferLen()>=6 && tcp.GetBuffer()[3]==TELQUAL_SEND) {
							   tcp.Send("\xff\xfa\x18\x0\x61\x6e\x73\x69\xff\xf0",10);
                			   tcp.BufferDel(6);
						    }
							break;
						default: ;
				   }
				   break;
        case NOP:  if (tcp.GetBufferLen()>=2) tcp.BufferDel(2); break;
        case DM:   if (tcp.GetBufferLen()>=2) tcp.BufferDel(2); break;
		case IAC:  tcp.BufferDel(1); break;
        default:   tcp.BufferDel(1);
	}
 }
}
