#if !defined(__CONSOLE_TELNET_PARAMS)
#define __CONSOLE_TELNET_PARAMS 1

#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define MAX_HOSTNAME    255
#define MAX_FILENAME    255
#define TELNET_PORT     23

#define _atoi(x)			atoi((char *)x)
#define _strncpy(s,t,n)		strncpy((char *)s,(char *)t,n)
#define _strcat(t,s)		strcat((char *)t,(char *)s)

class Params {
        unsigned char host[MAX_HOSTNAME+1];
        unsigned char debug[MAX_FILENAME+1];
		unsigned char tmlog[MAX_FILENAME+1];
        unsigned port;
		unsigned play;					// play recorded session
	public:
		int koi8;
        Params();
        Params(int,unsigned char **);
        void Init(int,unsigned char **);
		// member functions
        unsigned char * Host();         // host name to connect
        unsigned char * Debug();        // debug file name
        unsigned char * TmLog();        // timer file name
		unsigned Play();				// play flag
        unsigned Port();                // IP port to connect
};

#endif
