#if !defined(__CONSOLE_TELNET_MAIN)
#define __CONSOLE_TELNET_MAIN 1

#include <stdio.h>
#include <signal.h>
#include "arpa/telnet.h"
#include "params.h"
#include "tcpip.h"
#include "screen.h"

extern Screen scr;				// Telnet virtual screen 80x25
extern Params par;              // parsed command-line parameters

class CTelnetTCP : public CTcpIp {
	virtual void OnDisconnect();
};

extern CTelnetTCP tcp;			// Microsoft Win32 TCP/IP protocol

DWORD ProcessNetwork();         // Recieving data from TCP/IP socket
void ProcessIAC();				// Telnet control sequences processing

#define ALT_PRESSED		(LEFT_ALT_PRESSED|RIGHT_ALT_PRESSED)

extern unsigned char alt2koi[];
extern unsigned char koi2alt[];

char * TransMem(void *mem,unsigned ln,void *table);
char * TranStr(void *str,void *table);

#endif
