#include "main.h"

Params::Params() {host[0]=0; koi8=0; debug[0]=0; port=TELNET_PORT; play=0;}

Params::Params(int n,unsigned char **p) {Init(n,p);}

void Params::Init(int n,unsigned char **p)
{
 port=TELNET_PORT; koi8=0; play=0;

 if (n>1 && p[1][0]=='-') koi8=1;
 if (n>1 && p[1][0]=='+') play=1;

 switch (n-koi8-play)
       {
        case 2: _strncpy(host,p[1+koi8+play],MAX_HOSTNAME); break;
        case 3: _strncpy(host,p[1+koi8+play],MAX_HOSTNAME);
                if (isdigit(p[2+koi8+play][0]))
					port=_atoi(p[2+koi8+play]);
                else {
					_strncpy(debug,p[2+koi8+play],MAX_FILENAME);
					_strcat(debug,".log");
					_strncpy(tmlog,p[2+koi8+play],MAX_FILENAME);
					_strcat(tmlog,".tms");
				}
				break;
        case 4: _strncpy(host,p[1+koi8+play],MAX_HOSTNAME);
                if (isdigit(p[2+koi8+play][0])) {	// next port
					port=_atoi(p[2+koi8+play]);
					_strncpy(debug,p[3+koi8+play],MAX_FILENAME);
					_strcat(debug,".log");
					_strncpy(tmlog,p[2+koi8+play],MAX_FILENAME);
					_strcat(tmlog,".tms");
				}
				else {
					if (isdigit(p[3+koi8+play][0]))
						port=_atoi(p[3+koi8+play]);
					else {
						_strncpy(debug,p[2+koi8+play],MAX_FILENAME);
						_strcat(debug,".log");
						_strncpy(tmlog,p[2+koi8+play],MAX_FILENAME);
						_strcat(tmlog,".tms");
					}
				}
				break;
       }
}


unsigned char * Params::Host() {return host;}

unsigned char * Params::Debug() {return debug;}

unsigned char * Params::TmLog() {return tmlog;}

unsigned Params::Port() {return port;}

unsigned Params::Play() {return play;}
